package com.cisco.cuic.api.examples;

import java.util.Iterator;
import java.util.List;

import com.cisco.cuic.api.client.CuicServer;
import com.cisco.cuic.api.models.UserAPIAPICContainer;
import com.cisco.cuic.api.models.apic.APICContainerVirtualInfraStructurePolicy;

public class APICContainerVirtualInfraPolicyExample {

	public static void main(String[] args) throws Exception {
		
		createAPICVirtualInfraPolicy();
		
		updateAPICVirtualInfraPolicy();
		
		getAllAPICVirtualInfraPolicies();
		
		getAPICVirtualInfraPolicy();
		deleteAPICVirtualInfraPolicy();
		

		

	}

	private static void getAPICVirtualInfraPolicy() throws Exception {
		/*
		 * Fill-in the Cuic Server info.
		 */
		CuicServer server = CuicServer.getAPI("<IP address>", "<REST Key>", "https", 443);

		UserAPIAPICContainer instance = new UserAPIAPICContainer(server);
		
		List<APICContainerVirtualInfraStructurePolicy> list = instance.userAPIGetServiceContainerVirtualInfraPolicy("apicPolicy");
		for (Iterator iterator = list.iterator(); iterator.hasNext();) {
			APICContainerVirtualInfraStructurePolicy apicContainerVirtualInfraStructurePolicy = (APICContainerVirtualInfraStructurePolicy) iterator
					.next();
			System.out.println(" Profile Name : "+apicContainerVirtualInfraStructurePolicy.getPolicyName());			
			System.out.println(" Profile Description : "+apicContainerVirtualInfraStructurePolicy.getPolicyDescription());
			System.out.println(" Application Profile Name : "+apicContainerVirtualInfraStructurePolicy.getApplicationProfileName());
		}
		
	}

	private static void deleteAPICVirtualInfraPolicy() throws Exception {
		CuicServer server = CuicServer.getAPI("<IP address>", "<REST Key>", "https", 443);

		UserAPIAPICContainer instance = new UserAPIAPICContainer(server);
		APICContainerVirtualInfraStructurePolicy policy = new APICContainerVirtualInfraStructurePolicy();
		policy.setPolicyName("apicPolicy");
		
	boolean isDeleted = instance.userAPIDeleteServiceContainerVirtualInfraPolicy(policy);
		System.out.println("is Policy Deleted ?"+isDeleted);
		
	}

	private static void getAllAPICVirtualInfraPolicies() throws Exception {
		/*
		 * Fill-in the Cuic Server info.
		 */
		CuicServer server = CuicServer.getAPI("<IP address>", "<REST Key>", "https", 443);

		UserAPIAPICContainer instance = new UserAPIAPICContainer(server);
		
		List<APICContainerVirtualInfraStructurePolicy> list = instance.userAPIGetAllServiceContainerVirtualInfraPolicies();
		for (Iterator iterator = list.iterator(); iterator.hasNext();) {
			APICContainerVirtualInfraStructurePolicy apicContainerVirtualInfraStructurePolicy = (APICContainerVirtualInfraStructurePolicy) iterator
					.next();
			System.out.println(" Profile Name : "+apicContainerVirtualInfraStructurePolicy.getPolicyName());			
			System.out.println(" Profile Description : "+apicContainerVirtualInfraStructurePolicy.getPolicyDescription());
			System.out.println(" Application Profile Name : "+apicContainerVirtualInfraStructurePolicy.getApplicationProfileName());
		}
		
	}

	private static void updateAPICVirtualInfraPolicy() throws Exception {
		/*
		 * Fill-in the Cuic Server info.
		 */
		CuicServer server = CuicServer.getAPI("<IP address>", "<REST Key>", "https", 443);

		UserAPIAPICContainer instance = new UserAPIAPICContainer(server);
		APICContainerVirtualInfraStructurePolicy policy = new APICContainerVirtualInfraStructurePolicy();
		policy.setPolicyName("VIPolicy1");
		policy.setPolicyDescription("VIPolicy1 Description");
		policy.setApplicationProfileName("applicationProfileName");
		

		/**
		 * Update the service Container Virtual Infra Policy
		 */

		boolean obj = instance.userAPIUpdateServiceContainerVirtualInfraPolicy(policy);
		System.out.println(obj);
		
	}

	private static void createAPICVirtualInfraPolicy() throws Exception {
		/*
		 * Fill-in the Cuic Server info.
		 */
		CuicServer server = CuicServer.getAPI("<IP address>", "<REST Key>", "https", 443);

		UserAPIAPICContainer instance = new UserAPIAPICContainer(server);
		APICContainerVirtualInfraStructurePolicy policy = new APICContainerVirtualInfraStructurePolicy();
		policy.setPolicyName("VIPolicy1");
		policy.setPolicyDescription("VIPolicy1 Description");
		policy.setApplicationProfileName("applicationProfileName");
		boolean obj = instance.userAPICreateServiceContainerVirtualInfraPolicy(policy);
		System.out.println("Created Sucessfuly : " + obj);

		/**
		 * Update the service Container Virtual Infra Policy
		 */

		obj = instance.userAPIUpdateServiceContainerVirtualInfraPolicy(policy);
		System.out.println(obj);
		
	}

}
