package com.cisco.cuic.api.examples;

import java.util.ArrayList;
import java.util.List;

import com.cisco.cuic.api.client.CuicServer;
import com.cisco.cuic.api.models.UserAPIVMware;
import com.cisco.cuic.api.models.vmware.APIVMNICInputParams;
import com.cisco.cuic.api.models.vmware.APIVMNICOutputDetails;
import com.cisco.cuic.api.models.vmware.VMNICOutputDetails;
import com.cisco.cuic.api.models.vmware.VMNICsInputConfig;

public class AddVMNICsTest {

	public static void main(String[] args) throws Exception {
		CuicServer api = CuicServer.getAPI("172.31.234.172", "E052D5B0D1BD4B3199DEB36620AA0004", "http", 80);

		UserAPIVMware instance = new UserAPIVMware(api);

		List<VMNICsInputConfig> vNICConfig = new ArrayList<VMNICsInputConfig>();
		VMNICsInputConfig nicConfig = new VMNICsInputConfig();
		nicConfig.setPortGroupIdentity("vmware169@172.31.232.176@vSwitch0@ctr-sdk-pg-lan0@Virtual Machine Portgroup");
		nicConfig.setDHCP(true);
		nicConfig.setStaticIpPool(null);
		nicConfig.setSubnetMask(null);
		nicConfig.setGateway(null);

		vNICConfig.add(nicConfig);

		APIVMNICInputParams param = new APIVMNICInputParams();
		param.setVmId(38);
		param.setvNICConfig(vNICConfig);

		APIVMNICOutputDetails output = instance.userAPIAddVMNICs(param);
		System.out.println("VM Id: " + output.getVmId());

		for (VMNICOutputDetails details : output.getvNicDetails()) {
			System.out.println("Adaptor Name" + details.getAdapterName());
			System.out.println("MAC Address: " + details.getMacAddress());
			System.out.println("Static IP" + details.getStaticIpPool());
			System.out.println("Subnet Mask: " + details.getSubnetMask());
			System.out.println("Gateway: " + details.getGateway());
		}

	}

}
