package com.cisco.cuic.api.examples;

import com.cisco.cuic.api.client.CuicServer;
import com.cisco.cuic.api.models.UserAPIVMware;
import com.cisco.cuic.api.models.vmware.LinuxVMParams;
import com.cisco.cuic.api.models.vmware.ServiceDeliveryPolicyRequestParam;
import com.cisco.cuic.api.models.vmware.WindowsVMParams;

public class CreateSystemPolicyTest {
	public static void main(String[] args) throws Exception {
		CuicServer api = CuicServer.getAPI("172.29.110.194", "5AD45F2DC5ED441A9A743F1B219CC302", "http", 80);

		UserAPIVMware instance = new UserAPIVMware(api);

		ServiceDeliveryPolicyRequestParam service = new ServiceDeliveryPolicyRequestParam();
		LinuxVMParams linux = new LinuxVMParams();
		linux.setLinuxTimeZone("US/Pacific");
		linux.setLinuxVMmaxBootWaitTime(2);

		WindowsVMParams window = new WindowsVMParams();
		window.setOrganizationName("testOrganization");

		service.setPolicyName("test2");
		service.setPolicyDescription("test");
		service.setVmImageType("Linux Only");
		service.setHostNameTemplate("sample1");
		service.setLinuxVM(linux);
		service.setWindowsVM(window);
		service.setDnsDomain("dnsdomain");

		boolean policy = instance.userAPICreateVMwareSystemPolicy(service);
		System.out.println(policy);

	}

}
