package com.cisco.cuic.api.examples;

import java.util.List;

import com.cisco.cuic.api.client.CuicServer;
import com.cisco.cuic.api.models.UserAPIFencedContainer;
import com.cisco.cuic.api.models.servicecontainer.FencedContainerVirtualInfrastructurePolicy;

public class FencedContainerVirtualInfraPolicyExample {

	public static void main(String[] args) throws Exception {
		/*
		 * Fill-in the Cuic Server info.
		 */
		CuicServer server = CuicServer.getAPI("<IP address>", "<REST Key>", "https", 443);

		UserAPIFencedContainer instance = new UserAPIFencedContainer(server);
		FencedContainerVirtualInfrastructurePolicy policy = new FencedContainerVirtualInfrastructurePolicy();
		policy.setPolicyName("VIPolicy1");
		policy.setPolicyDescription("VIPolicy1 Description");
		policy.setVirtualAccountName("VNX_169");
		policy.setGatewayRequired(false);
		policy.setF5LoadBalancerRequired(false);

		boolean obj = instance.userAPICreateServiceContainerVirtualInfraPolicy(policy);
		System.out.println("Created Sucessfuly : " + obj);

		/**
		 * Update the service Container Virtual Infra Policy
		 */

		obj = instance.userAPIUpdateServiceContainerVirtualInfraPolicy(policy);
		System.out.println(obj);

		List<FencedContainerVirtualInfrastructurePolicy> list = instance
				.userAPIGetAllServiceContainerVirtualInfraPolicy();

	}

}
