package com.cisco.cuic.api.examples;

import java.util.List;

import com.cisco.cuic.api.client.CuicServer;
import com.cisco.cuic.api.models.UserAPICatalog;
import com.cisco.cuic.api.models.catalog.APICatalogParams;
import com.cisco.cuic.api.models.customaction.APIWorkflowOutputFieldDefinition;
import com.cisco.cuic.api.models.customaction.APIWorkflowOutputFieldDefinitionList;

public class GetCatalogOutput {

	public static void main(String[] args) throws Exception {
		CuicServer api = CuicServer.getAPI("172.29.110.241", "3E17CFFBA7A64C71B8958F40DE2EC9B3", "http", 80);

		UserAPICatalog catalog = new UserAPICatalog(api);
		APICatalogParams params = new APICatalogParams();
		params.setCatalogName("AdvCatalog");
		APIWorkflowOutputFieldDefinitionList def = catalog.userAPIGetCatalogOutputDefinition(params);
		List<APIWorkflowOutputFieldDefinition> list;
		if (def != null) {
			list = def.getWorkflowOutputFieldList();
		} else {
			throw new Exception("No output defination found!");
		}

		if (list != null && list.size() > 0) {
			for (int i = 0; i < list.size(); i++) {
				System.out.println("Field label: " + list.get(i).getOutputFieldLabel());
				System.out.println("Field name: " + list.get(i).getOutputFieldName());
				System.out.println("Field description: " + list.get(i).getOutputFieldDescription());
				System.out.println("Field type: " + list.get(i).getOutputFieldType());
			}
		} else {
			throw new Exception("No workflow output field found!");
		}
		// System.out.println("lisst = " +
		// list.getWorkflowOutputFieldList().get(0));

	}

}
