package com.cisco.cuic.api.examples;

import java.util.Iterator;
import java.util.List;

import com.cisco.cuic.api.client.APINameValue;
import com.cisco.cuic.api.client.CuicServer;
import com.cisco.cuic.api.models.UserAPIChargeBack;
import com.cisco.cuic.api.models.chargeback.APIGetCostModelParams;
import com.cisco.cuic.api.models.chargeback.APIGetCostModelResponse;
import com.cisco.cuic.api.models.chargeback.APIPhysicalServerCostModel;
import com.cisco.cuic.api.models.chargeback.APIVMCostModel;

import java.util.ArrayList;

public class GetCostModel {

	public static void main(String[] args) throws Exception {
		CuicServer api = CuicServer.getAPI("172.29.109.214", "3E17CFFBA7A64C71B8958F40DE2EC9B3", "http", 80);

		UserAPIChargeBack instance = new UserAPIChargeBack(api);

		List<APINameValue> requestParam = new ArrayList<APINameValue>();

		APIGetCostModelParams costParams = new APIGetCostModelParams();
		costParams.setVdcName("CostModel_Vdc");

		APINameValue value = new APINameValue();

		value.setName("CPU");
		value.setValue("1");
		requestParam.add(value);

		value = new APINameValue();
		value.setName("Memory");
		value.setValue("1");
		requestParam.add(value);

		value = new APINameValue();
		value.setName("Disk");
		value.setValue("1");
		requestParam.add(value);

		value = new APINameValue();
		value.setName("NetworkRx");
		value.setValue("1");
		requestParam.add(value);

		value = new APINameValue();
		value.setName("NetworkTx");
		value.setValue("1");
		requestParam.add(value);
		costParams.setCostModelResources(requestParam);

		APIGetCostModelResponse response = instance.userAPIGetCostModel(costParams);
		APIVMCostModel vmCostModel = response.getVmCostModel();
		APIPhysicalServerCostModel bmCostModel = response.getBMCostModel();
		System.out.println(vmCostModel.getMonthlyCost());

	}

}
