package com.cisco.cuic.api.examples;

import java.util.Iterator;
import java.util.List;
import java.util.ArrayList;

import com.cisco.cuic.api.client.APINameValue;
import com.cisco.cuic.api.client.APINameValueList;
import com.cisco.cuic.api.client.CuicServer;
import com.cisco.cuic.api.models.UserAPIChargeBack;
import com.cisco.cuic.api.models.chargeback.APICPUResourceUsageCost;
import com.cisco.cuic.api.models.chargeback.APIDiskResourceUsageCost;
//import com.cisco.cuic.api.models.chargeback.APINameValue;
//import com.cisco.cuic.api.models.chargeback.APINameValueList;
import com.cisco.cuic.api.models.chargeback.APIResourceUsageCostParams;
import com.cisco.cuic.api.models.chargeback.APIResourceUsageCostSummary;
import com.cisco.cuic.api.models.chargeback.APIResourceUsageCostSummaryResponse;

public class GetResourceUsageCostSummaryTest {

	public static void main(String[] args) throws Exception {
		CuicServer api = CuicServer.getAPI("172.29.110.128", "3E17CFFBA7A64C71B8958F40DE2EC9B3", "http", 80);

		UserAPIChargeBack instance = new UserAPIChargeBack(api);
		APIResourceUsageCostParams costParams = new APIResourceUsageCostParams();
		APINameValue value = new APINameValue();
		value.setName("vmid");
		value.setValue("56");
		List<APINameValue> requestParam = new ArrayList<APINameValue>();

		requestParam.add(value);
		costParams.setRequestParam(requestParam);
		costParams.setFromTimeInMilliSeconds(1442946600000l);
		costParams.setToTimeInMilliSeconds(1443032999000l);

		APIResourceUsageCostSummaryResponse response = instance.userAPIGetResourceUsageCostSummar(costParams);
		System.out.println("Duration :" + response.getDuration());
		System.out.println("ResourceType :" + response.getResourceType());
		APINameValueList list = response.getResponseParamList();
		List<APINameValue> apivalue = list.getList();
		for (int i = 0; i < apivalue.size(); i++) {
			System.out.println("Name :" + apivalue.get(i).getName());
			System.out.println("Value :" + apivalue.get(i).getValue());
		}

		List<APIResourceUsageCostSummary> summary = response.getResourceUsageCostSummary();
		for (int i = 0; i < summary.size(); i++) {
			System.out.println("catalogItemName :" + summary.get(i).getCatalogItemName());
			// System.out.println("cpuResourceUsageCost" +
			// summary.get(i).getCpuResourceUsageCost());

			APICPUResourceUsageCost[] cpus = summary.get(i).getCpuResourceUsageCost();
			for (int j = 0; j < cpus.length; j++) {
				System.out.println("Cpu_GHz_Hours : " + cpus[j].getCpu_GHz_Hours());
				System.out.println("CPU CoreCost : " + cpus[j].getCpuCoreCost());
				System.out.println("Cpu Cores :" + cpus[j].getCpuCores());
				System.out.println("Cpu Cost :" + cpus[j].getCpuCost());
				System.out.println("Reserved CpuGHZCost" + cpus[j].getReservedCpuGhzCost());
				System.out.println("Used Cpu Cost" + cpus[j].getUsedCpuGhzCost());
			}

		}

	}

}
