package com.cisco.cuic.api.examples;

import com.cisco.cuic.api.client.CuicServer;
import com.cisco.cuic.api.models.UserAPIVMware;
import com.cisco.cuic.api.models.vmware.LinuxVMParams;
import com.cisco.cuic.api.models.vmware.PrivateCloudSystemProfile;
import com.cisco.cuic.api.models.vmware.ServiceDeliveryPolicy;
import com.cisco.cuic.api.models.vmware.ServiceDeliveryPolicyRequestParam;
import com.cisco.cuic.api.models.vmware.WindowsVMParams;

public class GetSystemPolicyTest {

	public static void main(String[] args) throws Exception {
		CuicServer api = CuicServer.getAPI("172.29.110.194", "6BF80FA2C71E4844AFEB3877CFD60621", "http", 80);

		UserAPIVMware instance = new UserAPIVMware(api);

		ServiceDeliveryPolicyRequestParam service = new ServiceDeliveryPolicyRequestParam();

		service.setPolicyName("test2");

		ServiceDeliveryPolicy policy = instance.userAPIGetVMwareSystemPolicy(service);

		System.out.println("policyName:" + policy.getPolicyName());
		System.out.println("policyDescription:" + policy.getPolicyDescription());
		System.out.println("ImageType:" + policy.getVmImageType());
		System.out.println("maxBootTime :" + policy.getLinuxVM().getLinuxVMmaxBootWaitTime());

	}

}
