package com.cisco.cuic.api.examples;

import java.util.List;

import com.cisco.cuic.api.client.APIWorkflowInputDetail;
import com.cisco.cuic.api.client.APIWorkflowInputDetails;
import com.cisco.cuic.api.client.CuicServer;
import com.cisco.cuic.api.models.UserAPIGlobal;

public class GetWorkflowInputs {

	public static void main(String[] args) throws Exception {

		CuicServer api = CuicServer.getAPI("10.23.210.42", "3E17CFFBA7A64C71B8958F40DE2EC9B3", "http", 80);
		UserAPIGlobal instance = new UserAPIGlobal(api);

		APIWorkflowInputDetails details = instance.userAPIGetWorkflowInputs("Test1");
		List<APIWorkflowInputDetail> list = null;
		if (details != null) {
			list = details.getDetails();
		} else {
			throw new Exception("No workflow input defination found!");
		}
		if (list != null && list.size() > 0) {
			for (int i = 0; i < list.size(); i++) {
				System.out.println("Field Name: " + list.get(i).getName());
				System.out.println("Field Label: " + list.get(i).getLabel());
				System.out.println("Field Description: " + list.get(i).getDescription());
				System.out.println("Input Type: " + list.get(i).getType());
				System.out.println("Field Type: " + list.get(i).getInputFieldType());
			}
		} else {
			System.out.println("No workflow input found!");
		}
	}
}
