package com.cisco.cuic.api.examples;

import java.util.List;

import com.cisco.cuic.api.client.CuicServer;
import com.cisco.cuic.api.models.UserAPIWorkflow;
import com.cisco.cuic.api.models.customaction.APIWorkflowOutputFieldDefinition;
import com.cisco.cuic.api.models.customaction.APIWorkflowOutputFieldDefinitionList;

public class GetWorkflowOutputDef {

	public static void main(String[] args) throws Exception {

		CuicServer api = CuicServer.getAPI("10.23.210.42", "3E17CFFBA7A64C71B8958F40DE2EC9B3", "http", 80);
		UserAPIWorkflow instance = new UserAPIWorkflow(api);
		APIWorkflowOutputFieldDefinitionList def = instance.userAPIGetWorkflowOutputDefinition("Test1");
		List<APIWorkflowOutputFieldDefinition> list = null;
		if (def != null) {
			list = def.getWorkflowOutputFieldList();
		} else {
			throw new Exception("No workflow output defination found!");
		}
		if (list != null && list.size() > 0) {
			for (int i = 0; i < list.size(); i++) {
				System.out.println("Field Name: " + list.get(i).getOutputFieldName());
				System.out.println("Field Label: " + list.get(i).getOutputFieldLabel());
				System.out.println("Field Description: " + list.get(i).getOutputFieldDescription());
				System.out.println("Field Type: " + list.get(i).getOutputFieldType());
			}
		} else {
			System.out.println("No workflow output field found!");
		}

	}
}
