package com.cisco.cuic.api.examples;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Properties;

import com.cisco.cuic.api.client.APITabularReport;
import com.cisco.cuic.api.client.ContainerVirtualMachine;
import com.cisco.cuic.api.client.CuicServer;
import com.cisco.cuic.api.client.JSON;
import com.cisco.cuic.api.models.UserAPIFencedContainer;
import com.cisco.cuic.api.models.UserAPIGlobal;
import com.cisco.cuic.api.models.servicecontainer.APIFencedVirtualContainerTemplateConfig;
import com.cisco.cuic.api.models.servicecontainer.APIFencedVirtualMachineConfig;
import com.cisco.cuic.api.models.servicecontainer.APIServiceContainerTemplate;
import com.cisco.cuic.api.models.servicecontainer.ContainerDataObjects;
import com.cisco.cuic.api.models.servicecontainer.DFAConfig;
import com.cisco.cuic.api.models.servicecontainer.FencedContainerOptions;
import com.cisco.cuic.api.models.servicecontainer.FencedContainerPolicies;
import com.cisco.cuic.api.models.servicecontainer.FencedContainerWorkflowConfig;
import com.cisco.cuic.api.models.servicecontainer.FencedNetwork;
import com.cisco.cuic.api.models.servicecontainer.FencedVirtualMachineNetworkConfig;
import com.cisco.cuic.api.models.servicecontainer.NetworkConfigProvisionedPortGroup;
import com.cisco.cuic.api.models.servicecontainer.NetworkConfigRequest;
import com.cisco.cuic.api.models.servicecontainer.NetworkConfigResult;
import com.cisco.cuic.api.models.servicecontainer.NetworkTopology;
import com.cisco.cuic.api.models.servicecontainer.OutboundACL;
import com.cisco.cuic.api.models.servicecontainer.OwnerInfo;
import com.cisco.cuic.api.models.servicecontainer.PortMapping;
import com.cisco.cuic.api.models.servicecontainer.ServiceContainer;
import com.cisco.cuic.api.models.servicecontainer.ServiceContainervInfraPolciyDef;
import com.cisco.cuic.api.models.servicecontainer.ServiceContainervInfraPolicy;
import com.cisco.cuic.api.models.servicecontainer.VirtualSwitch;
import com.cloupia.sdk.api.CloupiaClient;
import com.google.gson.JsonObject;
import com.google.gson.JsonParser;

public class TestApplicationContainer {

	private static final String REST_SERVER_PROPERTIES = "rest-server.properties";
	private static final String UCSM_CONTEXT_NAME = "ucsm";
	private Properties props;
	private CloupiaClient client;
	private Map<String, String> reportLabelIdMap;
	private JsonObject obj;
	private JsonParser parser;

	public TestApplicationContainer() {
		// TODO Auto-generated constructor stub
	}

	public static void main(String[] args) throws Exception {
		TestApplicationContainer obj = new TestApplicationContainer();
		/*
		 * CuicServer api = CuicServer.getAPI(
		 * "172.29.110.192","83EFC147B0C44FC5A866C4F278F78D07", "http", 80);
		 */

		CuicServer server = CuicServer.getAPI("172.29.109.160", "E512309C9D934E07875A6263C9BE69A4", "https", 443);

		UserAPIFencedContainer fencedC = new UserAPIFencedContainer(server);
		/*
		 * executeGetVNCURL(fencedC);
		 * executeGetServiceContainerDetails(fencedC);
		 * executeGetApplicationContainerTemplateDetails(fencedC);
		 * executeCloneServiceContainer(fencedC);
		 * executeDeleteServiceContainer(fencedC);
		 * executeuserAPIPowerOffServiceContainer(fencedC);
		 * executeuserAPIPowerOnServiceContainer(fencedC);
		 * executeAddVMsServiceContainer(fencedC);
		 * executeGetServiceContainerData(fencedC);
		 * executeGetServiceContainerVirtualInfraPolicy(fencedC);
		 * executeGetAllServiceContainers(fencedC);
		 */

		// executeuserAPICreateServiceContainerTemplate(fencedC);
		// executeuserAPICreateServiceContainerTemplateWithOneObject(fencedC);

		// executeuserAPICreateServiceContainerTemplate(fencedC);
		// convert();
		executeuserAPIUpdateServiceContainerTemplate(fencedC);

	}

	public static void executeGetVNCURL(UserAPIFencedContainer fencedC) throws Exception {

		String result = fencedC.userAPIGetVNCURL("395");
		System.out.println(result);
	}

	public static void executeGetServiceContainerDetails(UserAPIFencedContainer fencedC) throws Exception {

		APITabularReport atr = new APITabularReport();
		atr = fencedC.userAPIGetServiceContainerDetails(1);

		List<Map<String, Object>> listofMaps = atr.getRows();
		// System.out.println("rows " + atr.getRowCount());
		for (Map<String, Object> map : listofMaps) {
			for (Entry<String, Object> entry : map.entrySet()) {
				// System.out.println(entry.getKey() + ":");
				String o = entry.toString();
				System.out.println(o);
			}
		}
	}

	public static void executeCloneServiceContainer(UserAPIFencedContainer fencedC) throws Exception {
		int srId = fencedC.userAPICloneServiceContainer("test", "cloned");
		System.out.println("Service Request" + srId);
	}

	public static void executeGetApplicationContainerTemplateDetails(UserAPIFencedContainer fencedC) throws Exception {

		APITabularReport atr = new APITabularReport();
		atr = fencedC.userAPIGetApplicationContainerTemplateDetails("PG Network");

		List<Map<String, Object>> listofMaps = atr.getRows();
		// System.out.println("rows " + atr.getRowCount());
		for (Map<String, Object> map : listofMaps) {
			for (Entry<String, Object> entry : map.entrySet()) {
				// System.out.println(entry.getKey() + ":");
				String o = entry.toString();
				System.out.println(o);
			}
		}
	}

	public static void executeDeleteServiceContainer(UserAPIFencedContainer fencedC) throws Exception {
		int crId = fencedC.userAPIDeleteServiceContainer(1);
		System.out.println("Container ID" + crId);
	}

	public static void executeuserAPIPowerOffServiceContainer(UserAPIFencedContainer fencedC) throws Exception {
		boolean result = fencedC.userAPIPowerOffServiceContainer(1);
		System.out.println("Result" + result);
	}

	public static void executeuserAPIPowerOnServiceContainer(UserAPIFencedContainer fencedC) throws Exception {
		boolean result = fencedC.userAPIPowerOnServiceContainer(1);
		System.out.println("Result" + result);
	}

	public static void executeAddVMsServiceContainer(UserAPIFencedContainer fencedC) throws Exception {

		ContainerVirtualMachine[] configs = new ContainerVirtualMachine[1];

		ContainerVirtualMachine a = new ContainerVirtualMachine();
		a.setAppName("Win");
		a.setQuantity(1);

		configs[0] = a;
		int obj = fencedC.userAPIAddVMsServiceContainer(1, configs);
		System.out.println("Result" + obj);
	}

	public static void executeGetServiceContainerData(UserAPIFencedContainer fencedC) throws Exception {
		ContainerDataObjects obj = fencedC.userAPIGetServiceContainerData(13);

		System.out.println(obj.getContainerId());

		NetworkConfigRequest ncr = obj.getNetworkRequest();
		OwnerInfo ni = ncr.getOwner();
		System.out.println(ni.getContainerId());
		System.out.println(ni.getSrId());

		NetworkConfigResult ncres = obj.getNetworkResult();
		NetworkConfigProvisionedPortGroup[] nppg = ncres.getProvisionedPortGroups();
		for (int i = 0; i < nppg.length; i++) {
			System.out.println(nppg[i].getPortGroup());
		}

		NetworkTopology nt = obj.getTopology();
		VirtualSwitch[] vs = nt.getVirtualSwitches();
		for (int i = 0; i < vs.length; i++) {
			System.out.println(vs[i].getNumPorts());
		}

	}

	public static void executeGetServiceContainerVirtualInfraPolicy(UserAPIFencedContainer fencedC) throws Exception {

		List obj = fencedC.userAPIGetServiceContainerVirtualInfraPolicy("testing");

		Iterator<ServiceContainervInfraPolicy> it = obj.iterator();
		while (it.hasNext()) {
			ServiceContainervInfraPolicy p = (ServiceContainervInfraPolicy) it.next();
			System.out.println(p.getPolicyName());
			System.out.println(p.getPolicyId());
			System.out.println(p.getvInfraPolicyDefinitionData());
			ServiceContainervInfraPolciyDef pd = p.getPolicyDef();
			DFAConfig dfa = pd.getDfaConfig();
			System.out.println(dfa.getSwitchName());
		}

	}

	private static void executeuserAPICreateServiceContainerTemplate(UserAPIFencedContainer fencedC) throws Exception {
		System.out.println("Strat");
		APIServiceContainerTemplate temp = new APIServiceContainerTemplate();
		temp.setTemplateName("sourabh by SDK  bundle TemplateName");
		temp.setTemplateDescription("test SDK templateDescription");

		APIFencedVirtualContainerTemplateConfig config = new APIFencedVirtualContainerTemplateConfig();
		String vInfraPolicy = "cloud82";
		config.setvInfraPolicy(vInfraPolicy);
		//
		List<FencedNetwork> networks = new ArrayList<FencedNetwork>();
		FencedNetwork net1 = new FencedNetwork();
		net1.setNetworkName("lan0");
		net1.setVlanIDPool("100-199");
		net1.setNetworkIP("10.10.10.0");
		net1.setNetworkMask("255.255.255.0");
		net1.setGatewayIP("10.10.10.1");

		networks.add(net1);
		FencedNetwork net2 = new FencedNetwork();
		net2.setNetworkName("lan1");
		net2.setVlanIDPool("200-299");
		net2.setNetworkIP("20.20.20.0");
		net2.setNetworkMask("255.255.255.0");
		net2.setGatewayIP("20.20.20.1");
		networks.add(net2);
		config.setNetworks(networks);

		List<APIFencedVirtualMachineConfig> vms = new ArrayList<APIFencedVirtualMachineConfig>();
		;

		APIFencedVirtualMachineConfig vm1 = new APIFencedVirtualMachineConfig();

		List<FencedVirtualMachineNetworkConfig> networkconfig = new ArrayList<FencedVirtualMachineNetworkConfig>();

		FencedVirtualMachineNetworkConfig networkconfig1 = new FencedVirtualMachineNetworkConfig();
		networkconfig1.setAppName("nic1");
		networkconfig1.setNetworkName("lan0");
		networkconfig1.setAdapterType("e1000");
		networkconfig1.setIpAddress("10.10.10.1");
		networkconfig.add(networkconfig1);

		FencedVirtualMachineNetworkConfig networkconfig2 = new FencedVirtualMachineNetworkConfig();
		networkconfig2.setAppName("nic2");
		networkconfig2.setNetworkName("lan1");
		networkconfig2.setAdapterType("e1000");
		networkconfig2.setIpAddress("20.20.20.1");
		networkconfig.add(networkconfig2);

		vm1.setNetworks(networkconfig);
		vm1.setNumVCPUs(1);
		vm1.setMemoryMB(128);
		vm1.setAppName("VM1");
		vm1.setImageId("FC_Gateway");

		vms.add(vm1);

		config.setVms(vms);

		List<PortMapping> portMappings = new ArrayList<PortMapping>();
		;

		PortMapping map1 = new PortMapping();
		int TCP = 6;
		int UDP = 17;
		map1.setProtocol(TCP);
		map1.setMappedPort(80);
		map1.setRemoteIP("10.10.10.2");
		map1.setRemotePort(80);

		portMappings.add(map1);

		config.setPortMappings(portMappings);

		List<OutboundACL> acl = new ArrayList<OutboundACL>();
		OutboundACL acl1 = new OutboundACL();
		acl1.setProtocol(TCP);
		acl1.setNetwork("lan0");
		acl1.setSrcCIDR("0.0.0.0/0");
		acl1.setDestCIDR("0.0.0.0/0");
		acl1.setFireallAction(0);
		acl.add(acl1);
		config.setOutboundACLs(acl);

		FencedContainerPolicies policies = new FencedContainerPolicies();
		policies.setVirtualComputePolicy("Cloud82 - Default Computing Policy");
		policies.setVirtualStoragePolicy("Cloud82 - Default Storage Policy");
		policies.setVirtualNetworkPolicy("Cloud82 - Default Network Policy");
		policies.setVirtualSystemPolicy("system test");
		policies.setCostModel("Default Cost Model");
		config.setPolicies(policies);

		FencedContainerOptions options = new FencedContainerOptions();
		options.setConsoleAccess(true);
		options.setSelfServiceDeleteContainer(true);
		options.setSelfServiceDeleteVM(true);
		options.setSelfServicePowerMgmt(true);
		options.setSelfServiceResize(true);
		options.setSelfServiceSnapshotMgmt(true);
		options.setSupportEmails("sougoyal@cisco.com");

		config.setOptions(options);

		FencedContainerWorkflowConfig workflowConfig = new FencedContainerWorkflowConfig();

		workflowConfig.setSetupWorkflow("48");

		config.setWorkflowConfig(workflowConfig);

		temp.setTemplateConfig(config);

		// boolean result = fencedC.userAPICreateServiceContainerTemplate(temp);
		boolean result = fencedC.userAPIUpdateServiceContainerTemplate(temp);
		System.out.println("Result" + result);

	}

	private static void executeuserAPIUpdateServiceContainerTemplate(UserAPIFencedContainer fencedC) throws Exception {
		System.out.println("Strat");
		APIServiceContainerTemplate temp = new APIServiceContainerTemplate();
		temp.setTemplateId(87);
		temp.setTemplateName("sourabh by SDK  bundle TemplateName");
		temp.setTemplateDescription("sourabh by SDK  bundle templateDescription");

		APIFencedVirtualContainerTemplateConfig config = new APIFencedVirtualContainerTemplateConfig();
		String vInfraPolicy = "cloudtest";
		config.setvInfraPolicy(vInfraPolicy);
		//
		List<FencedNetwork> networks = new ArrayList<FencedNetwork>();
		FencedNetwork net1 = new FencedNetwork();
		net1.setNetworkName("lan0");
		net1.setVlanIDPool("100-199");
		net1.setNetworkIP("10.10.10.0");
		net1.setNetworkMask("255.255.255.0");
		net1.setGatewayIP("10.10.10.1");

		networks.add(net1);
		FencedNetwork net2 = new FencedNetwork();
		net2.setNetworkName("lan1");
		net2.setVlanIDPool("200-299");
		net2.setNetworkIP("20.20.20.0");
		net2.setNetworkMask("255.255.255.0");
		net2.setGatewayIP("20.20.20.1");
		networks.add(net2);
		config.setNetworks(networks);

		List<APIFencedVirtualMachineConfig> vms = new ArrayList<APIFencedVirtualMachineConfig>();
		;

		APIFencedVirtualMachineConfig vm1 = new APIFencedVirtualMachineConfig();

		List<FencedVirtualMachineNetworkConfig> networkconfig = new ArrayList<FencedVirtualMachineNetworkConfig>();

		FencedVirtualMachineNetworkConfig networkconfig1 = new FencedVirtualMachineNetworkConfig();
		networkconfig1.setAppName("nic1");
		networkconfig1.setNetworkName("lan0");
		networkconfig1.setAdapterType("e1000");
		networkconfig1.setIpAddress("10.10.10.1");
		networkconfig.add(networkconfig1);

		FencedVirtualMachineNetworkConfig networkconfig2 = new FencedVirtualMachineNetworkConfig();
		networkconfig2.setAppName("nic2");
		networkconfig2.setNetworkName("lan1");
		networkconfig2.setAdapterType("e1000");
		networkconfig2.setIpAddress("20.20.20.1");
		networkconfig.add(networkconfig2);

		vm1.setNetworks(networkconfig);
		vm1.setNumVCPUs(1);
		vm1.setMemoryMB(128);
		vm1.setAppName("VM1");
		vm1.setImageId("FC_Gateway");

		vms.add(vm1);

		config.setVms(vms);

		List<PortMapping> portMappings = new ArrayList<PortMapping>();
		;

		PortMapping map1 = new PortMapping();
		int TCP = 6;
		int UDP = 17;
		map1.setProtocol(TCP);
		map1.setMappedPort(80);
		map1.setRemoteIP("10.10.10.2");
		map1.setRemotePort(80);

		portMappings.add(map1);

		config.setPortMappings(portMappings);

		List<OutboundACL> acl = new ArrayList<OutboundACL>();
		OutboundACL acl1 = new OutboundACL();
		acl1.setProtocol(TCP);
		acl1.setNetwork("lan0");
		acl1.setSrcCIDR("0.0.0.0/0");
		acl1.setDestCIDR("0.0.0.0/0");
		acl1.setFireallAction(0);
		acl.add(acl1);
		config.setOutboundACLs(acl);

		FencedContainerPolicies policies = new FencedContainerPolicies();
		policies.setVirtualComputePolicy("Cloud82 - Default Computing Policy");
		policies.setVirtualStoragePolicy("Cloud82 - Default Storage Policy");
		policies.setVirtualNetworkPolicy("Cloud82 - Default Network Policy");
		policies.setVirtualSystemPolicy("system test");
		policies.setCostModel("Default Cost Model");
		config.setPolicies(policies);

		FencedContainerOptions options = new FencedContainerOptions();
		options.setConsoleAccess(true);
		options.setSelfServiceDeleteContainer(true);
		options.setSelfServiceDeleteVM(true);
		options.setSelfServicePowerMgmt(true);
		options.setSelfServiceResize(true);
		options.setSelfServiceSnapshotMgmt(true);
		options.setSupportEmails("sougoyal@cisco.com");

		config.setOptions(options);

		FencedContainerWorkflowConfig workflowConfig = new FencedContainerWorkflowConfig();

		workflowConfig.setSetupWorkflow("2");

		config.setWorkflowConfig(workflowConfig);

		temp.setTemplateConfig(config);

		// boolean result = fencedC.userAPICreateServiceContainerTemplate(temp);
		boolean result = fencedC.userAPIUpdateServiceContainerTemplate(temp);
		System.out.println("Result" + result);

	}

	public static void executeGetAllServiceContainers(UserAPIFencedContainer fencedC) throws Exception {

		List<ServiceContainer> obj = fencedC.userAPIGetAllServiceContainers();
		for (ServiceContainer sc : obj) {
			// System.out.println("Label "+sc.getContainerLabel());
			System.out.println("State " + sc.getContainerState());
			System.out.println("VDC " + sc.getVdcId());
			System.out.println("SR " + sc.getSrId());
			System.out.println("Group " + sc.getGroupId());
			System.out.println();

		}

	}

	public static void executeGetAllVMs(UserAPIGlobal global) throws Exception {
		System.out.println("Before execute");
		APITabularReport obj = global.userAPIGetAllVMs();
		System.out.println("After execute" + obj);

	}

	public static void executeGetAllCatalogs(UserAPIGlobal global) throws Exception {
		APITabularReport obj = global.userAPIGetAllCatalogs();
		List<Map<String, Object>> listofMaps = obj.getRows();
		// System.out.println("rows " + atr.getRowCount());
		for (Map<String, Object> map : listofMaps) {
			for (Entry<String, Object> entry : map.entrySet()) {
				// System.out.println(entry.getKey() + ":");
				String o = entry.toString();
				System.out.println(o);
			}
		}
	}

	public static void convert() throws Exception {
		System.out.println("Start");
		String str = "{'templateId':1000,'templateType':'sample','templateName':'sourabh','templateDescription':'sample','containerType':'sample','templateDefinitionData':'sample','templateConfig':{'vInfraPolicy':'sample','networks':[{'networkName':'sample','networkType':1000,'vlanIDPool':'sample','networkPool':1000,'ipSubnetPool':1000,'networkIP':'sample','networkMask':'sample','gatewayIP':'sample'},{'networkName':'sample','networkType':1000,'vlanIDPool':'sample','networkPool':1000,'ipSubnetPool':1000,'networkIP':'sample','networkMask':'sample','gatewayIP':'sample'}],'dfaNetworks':[{'networkName':'sample','networkRole':'sample','description':'sample','networkType':1000,'profileName':'sample','gatewayIP':'sample','networkMask':'sample','dhcpServerAddress':'sample','gatewayIpv6Address':'sample','prefixLength':'sample','startIP':'sample','endIP':'sample','secondaryGateway':'sample'},{'networkName':'sample','networkRole':'sample','description':'sample','networkType':1000,'profileName':'sample','gatewayIP':'sample','networkMask':'sample','dhcpServerAddress':'sample','gatewayIpv6Address':'sample','prefixLength':'sample','startIP':'sample','endIP':'sample','secondaryGateway':'sample'}],'vnmcFirewallConfig':{'networkName':'sample','ipAddress':'sample'},'vnmcZones':[{'zoneName':'sample','zoneDesc':'sample','vnmcZoneRules':[{'attributeType':'sample','attributeName':'sample','operator':'sample','attributeValue':'sample','prefixedIpAddressValue':'sample','prefixedSubnetValue':'sample'},{'attributeType':'sample','attributeName':'sample','operator':'sample','attributeValue':'sample','prefixedIpAddressValue':'sample','prefixedSubnetValue':'sample'}]},{'zoneName':'sample','zoneDesc':'sample','vnmcZoneRules':[{'attributeType':'sample','attributeName':'sample','operator':'sample','attributeValue':'sample','prefixedIpAddressValue':'sample','prefixedSubnetValue':'sample'},{'attributeType':'sample','attributeName':'sample','operator':'sample','attributeValue':'sample','prefixedIpAddressValue':'sample','prefixedSubnetValue':'sample'}]}],'vnmcAcls':[{'name':'sample','descr':'sample','firewallAction':'sample','matchCriteria':'sample','protocolServiceOption':'sample','protocol':true,'protocalOperator':'sample','protocalValue':'sample','services':[{'protocalOperator':'sample','protocalValue':'sample','serviceName':'sample','servicePort':1000,'errormessage':'sample'},{'protocalOperator':'sample','protocalValue':'sample','serviceName':'sample','servicePort':1000,'errormessage':'sample'}],'srcRules':[{'attributeType':'sample','attributeName':'sample','operator':'sample','attributeValue':'sample','zoneAttributeValue':'sample','prefixedIpAddressValue':'sample','prefixedSubnetValue':'sample'},{'attributeType':'sample','attributeName':'sample','operator':'sample','attributeValue':'sample','zoneAttributeValue':'sample','prefixedIpAddressValue':'sample','prefixedSubnetValue':'sample'}],'destRules':[{'attributeType':'sample','attributeName':'sample','operator':'sample','attributeValue':'sample','zoneAttributeValue':'sample','prefixedIpAddressValue':'sample','prefixedSubnetValue':'sample'},{'attributeType':'sample','attributeName':'sample','operator':'sample','attributeValue':'sample','zoneAttributeValue':'sample','prefixedIpAddressValue':'sample','prefixedSubnetValue':'sample'}]},{'name':'sample','descr':'sample','firewallAction':'sample','matchCriteria':'sample','protocolServiceOption':'sample','protocol':true,'protocalOperator':'sample','protocalValue':'sample','services':[{'protocalOperator':'sample','protocalValue':'sample','serviceName':'sample','servicePort':1000,'errormessage':'sample'},{'protocalOperator':'sample','protocalValue':'sample','serviceName':'sample','servicePort':1000,'errormessage':'sample'}],'srcRules':[{'attributeType':'sample','attributeName':'sample','operator':'sample','attributeValue':'sample','zoneAttributeValue':'sample','prefixedIpAddressValue':'sample','prefixedSubnetValue':'sample'},{'attributeType':'sample','attributeName':'sample','operator':'sample','attributeValue':'sample','zoneAttributeValue':'sample','prefixedIpAddressValue':'sample','prefixedSubnetValue':'sample'}],'destRules':[{'attributeType':'sample','attributeName':'sample','operator':'sample','attributeValue':'sample','zoneAttributeValue':'sample','prefixedIpAddressValue':'sample','prefixedSubnetValue':'sample'},{'attributeType':'sample','attributeName':'sample','operator':'sample','attributeValue':'sample','zoneAttributeValue':'sample','prefixedIpAddressValue':'sample','prefixedSubnetValue':'sample'}]}],'vms':[{'templateName':'sample','zone':'sample','appName':'sample','appDescription':'sample','imageId':'sample','numVCPUs':1000,'memoryMB':1000,'cpuReservationMHz':1000,'memoryReservationMB':1000,'diskSize':1000,'passwordResetType':1000,'templateRootLogin':'sample','templateRootPassword':'sample','appCategory':'sample','isUseImageNetwork':true,'networks':[{'appName':'sample','networkName':'sample','adapterType':'sample','ipAddress':'sample','enablePublicIPMapping':true},{'appName':'sample','networkName':'sample','adapterType':'sample','ipAddress':'sample','enablePublicIPMapping':true}],'maxQuantity':1000,'initialQuantity':1000,'isStorageEfficiencyEnabled':true},{'templateName':'sample','zone':'sample','appName':'sample','appDescription':'sample','imageId':'sample','numVCPUs':1000,'memoryMB':1000,'cpuReservationMHz':1000,'memoryReservationMB':1000,'diskSize':1000,'passwordResetType':1000,'templateRootLogin':'sample','templateRootPassword':'sample','appCategory':'sample','isUseImageNetwork':true,'networks':[{'appName':'sample','networkName':'sample','adapterType':'sample','ipAddress':'sample','enablePublicIPMapping':true},{'appName':'sample','networkName':'sample','adapterType':'sample','ipAddress':'sample','enablePublicIPMapping':true}],'maxQuantity':1000,'initialQuantity':1000,'isStorageEfficiencyEnabled':true}],'portMappings':[{'protocol':1000,'mappedPort':1000,'remoteIP':'sample','remotePort':1000},{'protocol':1000,'mappedPort':1000,'remoteIP':'sample','remotePort':1000}],'outboundACLs':[{'protocol':1000,'network':'sample','srcCIDR':'sample','destCIDR':'sample','srcPortRange':'sample','destPortRange':'sample','fireallAction':1000},{'protocol':1000,'network':'sample','srcCIDR':'sample','destCIDR':'sample','srcPortRange':'sample','destPortRange':'sample','fireallAction':1000}],'policies':{'virtualComputePolicy':'sample','virtualStoragePolicy':'sample','virtualNetworkPolicy':'sample','virtualSystemPolicy':'sample','costModel':'sample','userActionPolicy':'sample'},'options':{'isSelfServicePowerMgmt':true,'isSelfServiceResize':true,'isSelfServiceSnapshotMgmt':true,'isSelfServiceDeleteVM':true,'isSelfServiceDeleteContainer':true,'isConsoleAccess':true,'supportEmails':'sample'},'gatewayConfig':{'gwPolicy':'sample','networkMapping':[{'network':'sample','networkIP':'sample','interfaceName':'sample'},{'network':'sample','networkIP':'sample','interfaceName':'sample'}],'isConfigGateway':true},'workflowConfig':{'setupWorkflow':'sample'},'templateName':'sample'}}";
		APIServiceContainerTemplate temp = (APIServiceContainerTemplate) JSON.jsonToJavaObject(str,
				APIServiceContainerTemplate.class);
		System.out.println("end" + temp.getTemplateName());

		String st = " (http://127.0.0.1//app/api/rest?formatType=json&opName=fenced:userAPICreateServiceContainerTemplateWithSuperOneObject"
				+ "&opData=%7Bparam0:%7B%22templateId%22:1000,%22templateType%22:%22sample%22,%22templateName%22:%22sample%22,"
				+ "%22templateDescription%22:%22sample%22,%22containerType%22:%22sample%22,%22templateDefinitionData%22:%22sample%22,%22templateConfig%22:"
				+ "%7B%22vInfraPolicy%22:%22sample%22,%22networks%22:%5B%7B%22networkName%22:%22sample%22,%22networkType%22:1000,%22vlanIDPool%22:%22sample%22,"
				+ "%22networkPool%22:1000,%22ipSubnetPool%22:1000,%22networkIP%22:%22sample%22,%22networkMask%22:%22sample%22,%22gatewayIP%22:%22sample%22%7D,"
				+ "%7B%22networkName%22:%22sample%22,%22networkType%22:1000,%22vlanIDPool%22:%22sample%22,%22networkPool%22:1000,%22ipSubnetPool%22:1000,"
				+ "%22networkIP%22:%22sample%22,%22networkMask%22:%22sample%22,%22gatewayIP%22:%22sample%22%7D%5D,%22dfaNetworks%22:%5B%7B%22networkName%22"
				+ ":%22sample%22,%22networkRole%22:%22sample%22,%22description%22:%22sample%22,%22networkType%22:1000,%22profileName%22:%22sample%22,%22"
				+ "gatewayIP%22:%22sample%22,%22networkMask%22:%22sample%22,%22dhcpServerAddress%22:%22sample%22,%22gatewayIpv6Address%22:%22sample%22"
				+ ",%22prefixLength%22:%22sample%22,%22startIP%22:%22sample%22,%22endIP%22:%22sample%22,%22secondaryGateway%22:%22sample%22%7D,"
				+ "%7B%22networkName%22:%22sample%22,%22networkRole%22:%22sample%22,%22description%22:%22sample%22,%22networkType%22:1000,"
				+ "%22profileName%22:%22sample%22,%22gatewayIP%22:%22sample%22,%22networkMask%22:%22sample%22,%22dhcpServerAddress%22:%22sample%22,"
				+ "%22gatewayIpv6Address%22:%22sample%22,%22prefixLength%22:%22sample%22,%22startIP%22:%22sample%22,%22endIP%22:%22sample%22,"
				+ "%22secondaryGateway%22:%22sample%22%7D%5D,%22vnmcFirewallConfig%22:%7B%22networkName%22:%22sample%22,%22ipAddress%22:%22sample%22%7D,"
				+ "%22vnmcZones%22:%5B%7B%22zoneName%22:%22sample%22,%22zoneDesc%22:%22sample%22,%22vnmcZoneRules%22:%5B%7B%22attributeType%22:%22sample%22,"
				+ "%22attributeName%22:%22sample%22,%22operator%22:%22sample%22,%22attributeValue%22:%22sample%22,%22prefixedIpAddressValue%22:%22sample%22,"
				+ "%22prefixedSubnetValue%22:%22sample%22%7D,%7B%22attributeType%22:%22sample%22,%22attributeName%22:%22sample%22,%22operator%22:%22sample%22,"
				+ "%22attributeValue%22:%22sample%22,%22prefixedIpAddressValue%22:%22sample%22,%22prefixedSubnetValue%22:%22sample%22%7D%5D%7D,%7B%22zoneName%22:"
				+ "%22sample%22,%22zoneDesc%22:%22sample%22,%22vnmcZoneRules%22:%5B%7B%22attributeType%22:%22sample%22,%22attributeName%22:%22sample%22,"
				+ "%22operator%22:%22sample%22,%22attributeValue%22:%22sample%22,%22prefixedIpAddressValue%22:%22sample%22,%22prefixedSubnetValue%22:"
				+ "%22sample%22%7D,%7B%22attributeType%22:%22sample%22,%22attributeName%22:%22sample%22,%22operator%22:%22sample%22,"
				+ "%22attributeValue%22:%22sample%22,%22prefixedIpAddressValue%22:%22sample%22,%22prefixedSubnetValue%22:%22sample%22%7D%5D%7D%5D,"
				+ "%22vnmcAcls%22:%5B%7B%22name%22:%22sample%22,%22descr%22:%22sample%22,%22firewallAction%22:%22sample%22,%22matchCriteria%22:%22sample%22,"
				+ "%22protocolServiceOption%22:%22sample%22,%22protocol%22:true,%22protocalOperator%22:%22sample%22,%22protocalValue%22:%22sample%22,"
				+ "%22services%22:%5B%7B%22protocalOperator%22:%22sample%22,%22protocalValue%22:%22sample%22,%22serviceName%22:%22sample%22,"
				+ "%22servicePort%22:1000,%22errormessage%22:%22sample%22%7D,%7B%22protocalOperator%22:%22sample%22,%22protocalValue%22:%22sample%22,"
				+ "%22serviceName%22:%22sample%22,%22servicePort%22:1000,%22errormessage%22:%22sample%22%7D%5D,%22srcRules%22:%5B%7B%22attributeType%22:"
				+ "%22sample%22,%22attributeName%22:%22sample%22,%22operator%22:%22sample%22,%22attributeValue%22:%22sample%22,%22zoneAttributeValue%22"
				+ ":%22sample%22,%22prefixedIpAddressValue%22:%22sample%22,%22prefixedSubnetValue%22:%22sample%22%7D,%7B%22attributeType%22:%22sample%22,"
				+ "%22attributeName%22:%22sample%22,%22operator%22:%22sample%22,%22attributeValue%22:%22sample%22,%22zoneAttributeValue%22:%22sample%22,"
				+ "%22prefixedIpAddressValue%22:%22sample%22,%22prefixedSubnetValue%22:%22sample%22%7D%5D,%22destRules%22:%5B%7B%22attributeType%22:%22sample%22,"
				+ "%22attributeName%22:%22sample%22,%22operator%22:%22sample%22,%22attributeValue%22:%22sample%22,%22zoneAttributeValue%22:%22sample%22,"
				+ "%22prefixedIpAddressValue%22:%22sample%22,%22prefixedSubnetValue%22:%22sample%22%7D,%7B%22attributeType%22:%22sample%22,%22attributeName%22:"
				+ "%22sample%22,%22operator%22:%22sample%22,%22attributeValue%22:%22sample%22,%22zoneAttributeValue%22:%22sample%22,%22prefixedIpAddressValue%22:"
				+ "%22sample%22,%22prefixedSubnetValue%22:%22sample%22%7D%5D%7D,%7B%22name%22:%22sample%22,%22descr%22:%22sample%22,%22firewallAction%22:"
				+ "%22sample%22,%22matchCriteria%22:%22sample%22,%22protocolServiceOption%22:%22sample%22,%22protocol%22:true,%22protocalOperator%22:"
				+ "%22sample%22,%22protocalValue%22:%22sample%22,%22services%22:%5B%7B%22protocalOperator%22:%22sample%22,%22protocalValue%22:%22sample%22,"
				+ "%22serviceName%22:%22sample%22,%22servicePort%22:1000,%22errormessage%22:%22sample%22%7D,%7B%22protocalOperator%22:%22sample%22,"
				+ "%22protocalValue%22:%22sample%22,%22serviceName%22:%22sample%22,%22servicePort%22:1000,%22errormessage%22:%22sample%22%7D%5D,"
				+ "%22srcRules%22:%5B%7B%22attributeType%22:%22sample%22,%22attributeName%22:%22sample%22,%22operator%22:%22sample%22,%22attributeValue%22"
				+ ":%22sample%22,%22zoneAttributeValue%22:%22sample%22,%22prefixedIpAddressValue%22:%22sample%22,%22prefixedSubnetValue%22:%22sample%22%7D,"
				+ "%7B%22attributeType%22:%22sample%22,%22attributeName%22:%22sample%22,%22operator%22:%22sample%22,%22attributeValue%22:%22sample%22,"
				+ "%22zoneAttributeValue%22:%22sample%22,%22prefixedIpAddressValue%22:%22sample%22,%22prefixedSubnetValue%22:%22sample%22%7D%5D,"
				+ "%22destRules%22:%5B%7B%22attributeType%22:%22sample%22,%22attributeName%22:%22sample%22,%22operator%22:%22sample%22,"
				+ "%22attributeValue%22:%22sample%22,%22zoneAttributeValue%22:%22sample%22,%22prefixedIpAddressValue%22:%22sample%22,"
				+ "%22prefixedSubnetValue%22:%22sample%22%7D,%7B%22attributeType%22:%22sample%22,%22attributeName%22:%22sample%22,"
				+ "%22operator%22:%22sample%22,%22attributeValue%22:%22sample%22,%22zoneAttributeValue%22:%22sample%22,"
				+ "%22prefixedIpAddressValue%22:%22sample%22,%22prefixedSubnetValue%22:%22sample%22%7D%5D%7D%5D,%22vms%22:%5B%7B%22templateName%22:"
				+ "%22sample%22,%22zone%22:%22sample%22,%22appName%22:%22sample%22,%22appDescription%22:%22sample%22,%22imageId%22:%22sample%22,%22numVCPUs%22"
				+ ":1000,%22memoryMB%22:1000,%22cpuReservationMHz%22:1000,%22memoryReservationMB%22:1000,%22diskSize%22:1000,%22passwordResetType%22:1000,"
				+ "%22templateRootLogin%22:%22sample%22,%22templateRootPassword%22:%22sample%22,%22appCategory%22:%22sample%22,%22isUseImageNetwork%22:true,"
				+ "%22networks%22:%5B%7B%22appName%22:%22sample%22,%22networkName%22:%22sample%22,%22adapterType%22:%22sample%22,%22ipAddress%22:%22sample%22"
				+ ",%22enablePublicIPMapping%22:true%7D,%7B%22appName%22:%22sample%22,%22networkName%22:%22sample%22,%22adapterType%22:%22sample%22,"
				+ "%22ipAddress%22:%22sample%22,%22enablePublicIPMapping%22:true%7D%5D,%22maxQuantity%22:1000,%22initialQuantity%22:1000,"
				+ "%22isStorageEfficiencyEnabled%22:true%7D,%7B%22templateName%22:%22sample%22,%22zone%22:%22sample%22,%22appName%22:%22sample%22,"
				+ "%22appDescription%22:%22sample%22,%22imageId%22:%22sample%22,%22numVCPUs%22:1000,%22memoryMB%22:1000,%22cpuReservationMHz%22:1000,"
				+ "%22memoryReservationMB%22:1000,%22diskSize%22:1000,%22passwordResetType%22:1000,%22templateRootLogin%22:%22sample%22,"
				+ "%22templateRootPassword%22:%22sample%22,%22appCategory%22:%22sample%22,%22isUseImageNetwork%22:true,%22networks%22:%5B%7B%22appName%22:"
				+ "%22sample%22,%22networkName%22:%22sample%22,%22adapterType%22:%22sample%22,%22ipAddress%22:%22sample%22,%22enablePublicIPMapping%22:true%7D,"
				+ "%7B%22appName%22:%22sample%22,%22networkName%22:%22sample%22,%22adapterType%22:%22sample%22,%22ipAddress%22:%22sample%22,"
				+ "%22enablePublicIPMapping%22:true%7D%5D,%22maxQuantity%22:1000,%22initialQuantity%22:1000,%22isStorageEfficiencyEnabled%22:"
				+ "true%7D%5D,%22portMappings%22:%5B%7B%22protocol%22:1000,%22mappedPort%22:1000,%22remoteIP%22:%22sample%22,%22remotePort%22:1000%7D,"
				+ "%7B%22protocol%22:1000,%22mappedPort%22:1000,%22remoteIP%22:%22sample%22,%22remotePort%22:1000%7D%5D,%22outboundACLs%22:%5B%7B%22protocol%22:"
				+ "1000,%22network%22:%22sample%22,%22srcCIDR%22:%22sample%22,%22destCIDR%22:%22sample%22,%22srcPortRange%22:%22sample%22,%22destPortRange%22:"
				+ "%22sample%22,%22fireallAction%22:1000%7D,%7B%22protocol%22:1000,%22network%22:%22sample%22,%22srcCIDR%22:%22sample%22,%22destCIDR%22:"
				+ "%22sample%22,%22srcPortRange%22:%22sample%22,%22destPortRange%22:%22sample%22,%22fireallAction%22:1000%7D%5D,%22policies%22:"
				+ "%7B%22virtualComputePolicy%22:%22sample%22,%22virtualStoragePolicy%22:%22sample%22,%22virtualNetworkPolicy%22:%22sample%22,"
				+ "%22virtualSystemPolicy%22:%22sample%22,%22costModel%22:%22sample%22,%22userActionPolicy%22:%22sample%22%7D,"
				+ "%22options%22:%7B%22isSelfServicePowerMgmt%22:true,%22isSelfServiceResize%22:true,%22isSelfServiceSnapshotMgmt%22:true,"
				+ "%22isSelfServiceDeleteVM%22:true,%22isSelfServiceDeleteContainer%22:true,%22isConsoleAccess%22:true,%22supportEmails%22:%22sample%22%7D,"
				+ "%22gatewayConfig%22:%7B%22gwPolicy%22:%22sample%22,%22networkMapping%22:%5B%7B%22network%22:%22sample%22,%22networkIP%22:%22sample%22,"
				+ "%22interfaceName%22:%22sample%22%7D,%7B%22network%22:%22sample%22,%22networkIP%22:%22sample%22,%22interfaceName%22:%22sample%22%7D%5D,"
				+ "%22isConfigGateway%22:true%7D,%22workflowConfig%22:%7B%22setupWorkflow%22:%22sample%22%7D,%22templateName%22:%22sample%22%7D%7D%7D)";
		System.out.println("end" + st.length());

	}
}
