package com.cisco.cuic.api.examples;

import java.io.File;
import java.io.FileInputStream;
import java.io.InputStream;
import java.util.Arrays;
import java.util.Properties;

import org.testng.annotations.AfterClass;
import org.testng.annotations.AfterTest;
import org.testng.annotations.BeforeClass;
import org.testng.annotations.BeforeTest;
import org.testng.annotations.DataProvider;
import org.testng.annotations.Test;

import com.cloupia.sdk.api.CloupiaClient;

public class TestServiceRequests {
	private static final String REST_SERVER_PROPERTIES = "rest-server.properties";

	private Properties props;
	private CloupiaClient client;

	@BeforeClass
	public void beforeClass() throws Exception {

	}

	@AfterClass
	public void afterClass() {
	}

	@DataProvider(name = "service_request_id")
	public Object[][] dp() {
		return new Object[][] { new Object[] { "608" }
				// new Object[]{"291"}

		};
	}

	@DataProvider(name = "create_service_request_params")
	public Object[][] dp2() {
		return new Object[][] { new Object[] { "QA_Catalog", "QA_vDC", "-1", "-1", "1", "provisioning a VM" }

		};
	}

	@BeforeTest
	public void beforeTest() throws Exception {
		System.out.println("current dir : " + System.getProperty("user.dir"));
		// InputStream is =
		// this.getClass().getResourceAsStream(REST_SERVER_PROPERTIES);
		InputStream is = new FileInputStream(new File(REST_SERVER_PROPERTIES));
		props = new Properties();
		props.load(is);
		client = new CloupiaClient(props.getProperty("server-address"),
				Integer.parseInt(props.getProperty("server-port", "443")), props.getProperty("rest-api-access-key"));

	}

	@AfterTest
	public void afterTest() {
	}

	@Test
	public void getServiceRequests() throws Exception {
		System.out.println(client.sendJSONRequest("userAPIGetServiceRequests", null));
	}

	// API to create service request to provision a VM
	@Test(dataProvider = "create_service_request_params")
	public void testCreateServiceRequest(String catalogName, String vdcName, String durationHours, String beginTime,
			String qty, String comments) throws Exception {

		System.out.println("test create service request : " + client.sendJSONRequest("userAPISubmitServiceRequest",
				Arrays.asList(new String[] { catalogName, vdcName, durationHours, beginTime, qty, comments })));
	}

	@Test
	public void getChargebackDetails() throws Exception {
		System.out.println(client.sendJSONRequest("userAPIResourceChargebackDetailsByGroup",
				Arrays.asList(new String[] { "Default Group" })));
	}

	@Test
	public void getResourceLimitsForMyGroup() throws Exception {
		System.out.println(client.sendJSONRequest("userAPIGetResourceLimitsForMyGroup", null));
	}

	@Test(dataProvider = "service_request_id")
	public void getServiceRequestDetails(String requestId) throws Exception {
		System.out.println(
				client.sendJSONRequest("userAPIGetServiceRequestDetails", Arrays.asList(new String[] { requestId })));
	}

	@Test(dataProvider = "service_request_id")
	public void testCancelServiceRequest(String requestId) throws Exception {
		client.sendJSONRequest("userAPICancelServiceRequest", Arrays.asList(new String[] { requestId }));
	}

	@Test(dataProvider = "service_request_id")
	public void getServiceRequestWorkflow(String requestId) throws Exception {
		System.out.println(
				client.sendJSONRequest("userAPIGetServiceRequestWorkflow", Arrays.asList(new String[] { requestId })));
	}

	@Test(dataProvider = "service_request_id")
	public void getWorkflowStatus(String requestId) throws Exception {
		System.out
				.println(client.sendJSONRequest("userAPIGetWorkflowStatus", Arrays.asList(new String[] { requestId })));
	}

	@Test
	public void getResourceAccountingDetails() throws Exception {
		System.out.println(client.sendJSONRequest("userAPIGetResourceAccountingDetails", null));
	}

	@Test
	public void getResourceAccounting() throws Exception {
		System.out.println(client.sendJSONRequest("userAPIGetResourceAccounting", null));
	}

}
