package com.cisco.cuic.api.examples;

import java.io.ByteArrayOutputStream;
import java.util.Map;

import javax.xml.stream.XMLOutputFactory;
import javax.xml.stream.XMLStreamWriter;

public class XMLRequestUtil {

	private static final String PAYLOAD = "payload";
	private static final String OPERATION_TYPE = "operationType";
	private static final String CUIC_OPERATION_REQUEST = "cuicOperationRequest";

	public static String constructXmlPayload(String xmlRootElement, Map<String, String> inputParams) throws Exception {
		ByteArrayOutputStream baos = new ByteArrayOutputStream();
		XMLOutputFactory factory = XMLOutputFactory.newInstance();

		XMLStreamWriter writer = factory.createXMLStreamWriter(baos);
		writer.writeStartElement(xmlRootElement);
		for (Map.Entry<String, String> mapEntry : inputParams.entrySet()) {
			writer.writeStartElement(mapEntry.getKey());
			writer.writeCharacters(mapEntry.getValue());
			writer.writeEndElement();
		}
		writer.writeEndElement();
		writer.flush();

		writer.close();
		return baos.toString();

	}

	public static String constructInputXml(String operationType, String inputPayload) throws Exception {

		ByteArrayOutputStream baos = new ByteArrayOutputStream();
		XMLOutputFactory factory = XMLOutputFactory.newInstance();
		XMLStreamWriter writer = factory.createXMLStreamWriter(baos);
		writer.writeStartElement(CUIC_OPERATION_REQUEST);
		if (operationType != null) {
			writer.writeStartElement(OPERATION_TYPE);
			writer.writeCharacters(operationType);
			writer.writeEndElement();
		}

		writer.writeStartElement(PAYLOAD);
		writer.writeCData(inputPayload);
		writer.writeEndElement();
		writer.writeEndElement();
		writer.flush();
		writer.close();
		return baos.toString();

	}

}
